(*********************************************************************)
(* Dir95 - biblioteka funkcji obs?uguj?cych d?ugie nazwy plik?w      *)
(* i katalog?w pod Win9x (FindFirst/FindNext, Rename, MkDir).        *)
(* Propozycje wszelkich zmian, dodatk?w i udoskonale? prosz? wysy?a? *)
(* na adres lfronczy@elka.pw.edu.pl         (c) 2001 ?ukasz Fronczyk *)
(* Autor tej biblioteki nie ponosi odpowiedzialno?ci za ewentualne   *)
(* zniszczenia spowodowane jej nieprawid?owym wykorzystywaniem.      *)
(*********************************************************************)

{$O+,G+}
unit dir95;
interface
uses dos,strings;
type
  FindData = record
               handle           : word;
               attribs          : longint;
               creationtime     : array[1..2] of longint;
               lastaccestime    : array[1..2] of longint;
               lastmodifytime   : array[1..2] of longint;
               filesize_high    : longint;
               filesize_low     : longint;
               reserved         : array[1..8] of char;
               fullfilename     : array[1..260] of char;
               shortfilename    : array[1..14] of char;
             end;

  string12 = string[12];

{ Spos?b dzia?ania wi?kszo?ci funkcji jest analogiczny do ich
  odpowiednik?w z modu?u dos. B??dy z? zg?aszane przez zmienn?
  DosError oraz przez warto?? zwracan? przez funkcj?.
  0 oznacza sukces.
  D?uga nazwa mo?e mie? maksymalnie 254 znaki, je?li pojawi si?
  jaka? d?u?sza to mog? by? problemy.
  Aby skorzysta? z dowolnej z poni?szych funkcji, nale?y si?
  upewni? czy w tle dzia?a Windows }
function WinVer : word; {= 0 dos, <> 0 Win w tle}


function findfirst95(const path : array of char;attrib : word;
                     var dane : FindData) : integer;
{ funkcja analogiczna do findfirst; definicja rekordu FindData
  znajduje si? na pocz?tku tej biblioteki}

function findnext95(var dane : FindData) : integer;
{ j.w. }
procedure TermFind(var dane : FindData);
{ t? procedur? MUSISZ wywo?a? po zako?czeniu poszukiwania
  aby zwolni? zasoby Windozy; je?li poszukiwanie jest nieudane
  (n.p.: je?li wyszukujesz '*.*' a? do wyczerpania plik?w
  w katalogu - na sam koniec dostaniesz b??d 18 - No More Files)
  to procedura ta jest wywo?ywana automatycznie.          }


procedure wfindfirst(path : PathStr;Attr: Word;var F: SearchRec);
{ analogiczna do findfirst; zwraca nazwy obci?te do 12 znak?w :( }
procedure wfindnext(var F: SearchRec);
{ j.w. }

function WinExpName(name : string) : string;
{ podajesz kr?tk? nazw? pliku/katalogu - otrzymujesz d?ug?,
  np.: WinExpName('c:\Progra~1') = 'C:\Program Files' }
function WinExpName12(name : string) : string12;
{ j.w. ale nazwa jest obci?ta do 12 znak?w }

function Rename_95(const s,d : array of char) : boolean;
{ zmienia nazw? pliku/katalogu s na d - na typie ^PChar}
function Rename95(s,d : string) : boolean;
{ zmienia nazw? pliku/katalogu s na d }
function MkDir_95(const d : array of char) : boolean;
{ zak?ada nowy katalog - na typie ^PChar}
function MkDir95(d : string) : boolean;
{ zak?ada nowy katalog }

implementation

function WinVer : word; { = 0 dos, <> 0 windoza} assembler;
{ 4.0 = Win95}
asm
mov ax,160Ah
int 2Fh
cmp ax,0
jz @@1
mov ax,0
jmp @@2
@@1:
mov ax,bx
@@2:
end;


function findfirst95; assembler;
asm
  mov DosError,0
  push ds
  mov ax,714Eh
  mov si,1
  mov cx,attrib
  lds dx,path
  les di,dane
  add di,2    {bo ten bufor liczy si? bez pierwszego worda}

  int 21h

  les di,dane
  mov [es:di],ax
  pop ds

  jc @@1
  xor ax,ax
  jmp @@2
@@1:
  mov doserror,ax
@@2:
end;

function findnext95; assembler;
asm
mov DosError,0
mov ax,714Fh
mov si,1

les di,dane
mov bx,[es:di]
add di,2

int 21h
  jc @@1
  xor ax,ax
  jmp @@2
@@1:
  mov DosError,ax {b??d; wywo?ujemy TermFind}
  mov cx,ax
  mov ax,71A1h
  les di,dane
  mov bx,[es:di]
  int 21h
  mov ax,cx
@@2:
end;

procedure TermFind; assembler;
asm
  mov DosError,0
  mov ax,71A1h
  les di,dane
  mov bx,[es:di]
  int 21h
end;

function WinExpName(name : string) : string;
var
{  a      : array[1..256] of char;}
  dane   : FindData;
{  b      : word;
  handle : word;}

begin
name := name + #0;
{move(name[1],a,length(name));}

findfirst95(name[1],$FF,dane);
if DosError <> 0 then
begin
  dec(name[0]);
  WinExpName := name;
  exit;
end;
TermFind(dane);

{move(dane.fullfilename,name[1],255);
name[0] := #255;
b := pos(#0,name);
if b > 0 then name[0] := char(b-1);}

WinExpName := Strpas(@dane.fullfilename);
end;


function WinExpName12(name : string) : string12;
var
{  a      : array[1..256] of char;}
  dane   : FindData;
{  b      : word;
  handle : word;}

begin
name := name + #0;
{move(name[1],a,length(name));}
if findfirst95(name[1],$FF,dane) > 0 then
begin
  dec(name[0]);
  WinExpName12 := name;
  exit;
end;
{move(dane.fullfilename,name[1],12);}
TermFind(dane);
WinExpName12 := copy(StrPas(@dane.fullfilename),1,12)+'                 ';
end;

function Rename_95(const s,d : array of char) : boolean; assembler;
asm
  push ds
  mov DosError,0
  lds dx,s
  les di,d
  mov ax,7156h
  int 21h
  jc @@1
  mov DosError,0
  jmp @@2
@@1:
  mov DosError,ax { > $FF = OK }
@@2:
  pop ds
end;


function Rename95(s,d : string) : boolean;
begin
  s := s + #0;
  d := d + #0;
  Rename95 := Rename_95(s[1],d[1]);
end;

function MkDir_95(const d : array of char) : boolean; assembler;
asm
  push ds
  lds dx,d
  mov ax,7139h
  int 21h
  mov DosError,ax { > $FF = OK }
  jc @@1
  mov DosError,0
  jmp @@2
@@1:
  mov DosError,ax { > $FF = OK }
@@2:
  pop ds
end;

function MkDir95(d : string) : boolean;
begin
 d := d + #0;
 MkDir95 := MkDir_95(d[1]);
end;

var
  handle : word;

procedure wfindfirst;
var
  a      : array[1..255] of char;
  d      : FindData;

begin
path := path + #0;
findfirst95(path[1],attr,d);
handle := d.handle;
if DosError > 0 then exit;

f.size := d.filesize_low;
f.time := d.lastmodifytime[1];
f.attr := d.attribs;

move(d.FullFileName,f.name[1],12);
if d.ShortFileName[1] <> #0 then
  move(d.ShortFileName,f.fill,14)
else
  move(d.FullFileName,f.fill,14);

f.name[0] := #12;
if pos(#0,f.name) > 0 then f.name[0] := char(pos(#0,f.name)-1)

end;


procedure wfindnext(var F: SearchRec);
var
  d      : FindData;

begin
d.handle := handle;
findnext95(d);
if DosError > 0 then begin TermFind(d); exit; end;
move(d.FullFileName,f.name[1],12);

if d.ShortFileName[1] > #0 then
move(d.ShortFileName,f.fill,14) else
move(d.FullFileName,f.fill,14);

f.size := d.filesize_low;
f.time := d.lastmodifytime[1];
f.attr := d.attribs;
f.name[0] := #12;
if pos(#0,f.name) > 0 then f.name[0] := char(pos(#0,f.name)-1)
end;


end.